diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/traffic-control/test/pie-queue-disc-test-suite.cc ns-3.32/src/traffic-control/test/pie-queue-disc-test-suite.cc
--- ns-3.31/src/traffic-control/test/pie-queue-disc-test-suite.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/traffic-control/test/pie-queue-disc-test-suite.cc	2020-10-06 15:35:43.000000000 -0700
@@ -46,12 +46,31 @@
    *
    * \param p the packet
    * \param addr the address
+   * \param ecnCapable ECN capable flag
    */
-  PieQueueDiscTestItem (Ptr<Packet> p, const Address & addr);
+  PieQueueDiscTestItem (Ptr<Packet> p, const Address & addr, bool ecnCapable);
   virtual ~PieQueueDiscTestItem ();
   virtual void AddHeader (void);
   virtual bool Mark (void);
 
+  // ** Variables for testing m_isCapDropAdjustment
+  double m_maxDropProbDiff = 0.0;   //!< Maximum difference between two consecutive drop probability values
+  double m_prevDropProb = 0.0;      //!< Previous drop probability
+  bool m_checkProb = false;         //!< Enable/Disable drop probability checks
+
+  // ** Variable for testing ECN
+  double m_maxDropProb = 0.0;       //!< Maximum value of drop probability
+  bool m_ecnCapable = false;        //!< Enable/Disable ECN capability
+
+  // ** Variables for testing Derandomization
+  bool m_checkAccuProb = false;     //!< Enable/Disable accumulated drop probability checks
+  bool m_constAccuProb = false;     //!< Enable/Disable fixed accumulated drop probability
+  bool m_checkMaxAccuProb = false;  //!< Enable/Disable Maximum accumulated drop probability checks
+  double m_accuProbError = 0.0;     //!< Error in accumulated drop probability
+  double m_prevAccuProb = 0.0;      //!< Previous accumulated drop probability
+  double m_setAccuProb = 0.0;       //!< Value to be set for accumulated drop probability
+  uint32_t m_expectedDrops = 0;     //!< Number of expected unforced drops
+
 private:
   PieQueueDiscTestItem ();
   /**
@@ -65,10 +84,11 @@
    * Disable default implementation to avoid misuse
    */
   PieQueueDiscTestItem &operator = (const PieQueueDiscTestItem &);
+  bool m_ecnCapablePacket; //!< ECN capable packet?
 };
 
-PieQueueDiscTestItem::PieQueueDiscTestItem (Ptr<Packet> p, const Address & addr)
-  : QueueDiscItem (p, addr, 0)
+PieQueueDiscTestItem::PieQueueDiscTestItem (Ptr<Packet> p, const Address & addr, bool ecnCapable)
+  : QueueDiscItem (p, addr, 0), m_ecnCapablePacket (ecnCapable)
 {
 }
 
@@ -84,6 +104,10 @@
 bool
 PieQueueDiscTestItem::Mark (void)
 {
+  if (m_ecnCapablePacket)
+    {
+      return true;
+    }
   return false;
 }
 
@@ -104,15 +128,17 @@
    * \param queue the queue disc
    * \param size the size
    * \param nPkt the number of packets
+   * \param testAttributes attributes for testing
    */
-  void Enqueue (Ptr<PieQueueDisc> queue, uint32_t size, uint32_t nPkt);
+  void Enqueue (Ptr<PieQueueDisc> queue, uint32_t size, uint32_t nPkt, Ptr<PieQueueDiscTestItem> testAttributes);
   /**
    * Enqueue with delay function
    * \param queue the queue disc
    * \param size the size
    * \param nPkt the number of packets
+   * \param testAttributes attributes for testing
    */
-  void EnqueueWithDelay (Ptr<PieQueueDisc> queue, uint32_t size, uint32_t nPkt);
+  void EnqueueWithDelay (Ptr<PieQueueDisc> queue, uint32_t size, uint32_t nPkt, Ptr<PieQueueDiscTestItem> testAttributes);
   /**
    * Dequeue function
    * \param queue the queue disc
@@ -131,6 +157,24 @@
    * \param mode the test mode
    */
   void RunPieTest (QueueSizeUnit mode);
+  /**
+   * \brief Check Drop Probability
+   * \param queue the queue disc
+   * \param testAttributes attributes for testing
+   */
+  void CheckDropProb (Ptr<PieQueueDisc> queue, Ptr<PieQueueDiscTestItem> testAttributes);
+  /**
+   * \brief Check Accumulated Drop Probability
+   * \param queue the queue disc
+   * \param testAttributes attributes for testing
+   */
+  void CheckAccuProb (Ptr<PieQueueDisc> queue, Ptr<PieQueueDiscTestItem> testAttributes);
+  /**
+   * \brief Check Maximum Accumulated Drop Probability
+   * \param queue the queue disc
+   * \param testAttributes attributes for testing
+   */
+  void CheckMaxAccuProb (Ptr<PieQueueDisc> queue, Ptr<PieQueueDiscTestItem> testAttributes);
 };
 
 PieQueueDiscTestCase::PieQueueDiscTestCase ()
@@ -152,6 +196,8 @@
 
   // test 1: simple enqueue/dequeue with defaults, no drops
   Address dest;
+  // PieQueueDiscItem pointer for attributes
+  Ptr<PieQueueDiscTestItem> testAttributes = Create<PieQueueDiscTestItem> (Create<Packet> (pktSize), dest, false);
 
   if (mode == QueueSizeUnit::BYTES)
     {
@@ -176,16 +222,16 @@
 
   queue->Initialize ();
   NS_TEST_EXPECT_MSG_EQ (queue->GetCurrentSize ().GetValue (), 0 * modeSize, "There should be no packets in there");
-  queue->Enqueue (Create<PieQueueDiscTestItem> (p1, dest));
+  queue->Enqueue (Create<PieQueueDiscTestItem> (p1, dest, false));
   NS_TEST_EXPECT_MSG_EQ (queue->GetCurrentSize ().GetValue (), 1 * modeSize, "There should be one packet in there");
-  queue->Enqueue (Create<PieQueueDiscTestItem> (p2, dest));
+  queue->Enqueue (Create<PieQueueDiscTestItem> (p2, dest, false));
   NS_TEST_EXPECT_MSG_EQ (queue->GetCurrentSize ().GetValue (), 2 * modeSize, "There should be two packets in there");
-  queue->Enqueue (Create<PieQueueDiscTestItem> (p3, dest));
-  queue->Enqueue (Create<PieQueueDiscTestItem> (p4, dest));
-  queue->Enqueue (Create<PieQueueDiscTestItem> (p5, dest));
-  queue->Enqueue (Create<PieQueueDiscTestItem> (p6, dest));
-  queue->Enqueue (Create<PieQueueDiscTestItem> (p7, dest));
-  queue->Enqueue (Create<PieQueueDiscTestItem> (p8, dest));
+  queue->Enqueue (Create<PieQueueDiscTestItem> (p3, dest, false));
+  queue->Enqueue (Create<PieQueueDiscTestItem> (p4, dest, false));
+  queue->Enqueue (Create<PieQueueDiscTestItem> (p5, dest, false));
+  queue->Enqueue (Create<PieQueueDiscTestItem> (p6, dest, false));
+  queue->Enqueue (Create<PieQueueDiscTestItem> (p7, dest, false));
+  queue->Enqueue (Create<PieQueueDiscTestItem> (p8, dest, false));
   NS_TEST_EXPECT_MSG_EQ (queue->GetCurrentSize ().GetValue (), 8 * modeSize, "There should be eight packets in there");
 
   Ptr<QueueDiscItem> item;
@@ -217,17 +263,13 @@
 
   // test 2: more data with defaults, unforced drops but no forced drops
   queue = CreateObject<PieQueueDisc> ();
+  // PieQueueDiscItem pointer for attributes
+  testAttributes = Create<PieQueueDiscTestItem> (Create<Packet> (pktSize), dest, false);
   pktSize = 1000;  // pktSize != 0 because DequeueThreshold always works in bytes
   NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("MaxSize", QueueSizeValue (QueueSize (mode, qSize))),
                          true, "Verify that we can actually set the attribute MaxSize");
-  NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("A", DoubleValue (0.125)), true,
-                         "Verify that we can actually set the attribute A");
-  NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("B", DoubleValue (1.25)), true,
-                         "Verify that we can actually set the attribute B");
   NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("Tupdate", TimeValue (Seconds (0.03))), true,
                          "Verify that we can actually set the attribute Tupdate");
-  NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("Supdate", TimeValue (Seconds (0.0))), true,
-                         "Verify that we can actually set the attribute Supdate");
   NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("DequeueThreshold", UintegerValue (10000)), true,
                          "Verify that we can actually set the attribute DequeueThreshold");
   NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("QueueDelayReference", TimeValue (Seconds (0.02))), true,
@@ -235,7 +277,7 @@
   NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("MaxBurstAllowance", TimeValue (Seconds (0.1))), true,
                          "Verify that we can actually set the attribute MaxBurstAllowance");
   queue->Initialize ();
-  EnqueueWithDelay (queue, pktSize, 400);
+  EnqueueWithDelay (queue, pktSize, 400, testAttributes);
   DequeueWithDelay (queue, 0.012, 400);
   Simulator::Stop (Seconds (8.0));
   Simulator::Run ();
@@ -247,16 +289,12 @@
 
   // test 3: same as test 2, but with higher QueueDelayReference
   queue = CreateObject<PieQueueDisc> ();
+  // PieQueueDiscItem pointer for attributes
+  testAttributes = Create<PieQueueDiscTestItem> (Create<Packet> (pktSize), dest, false);
   NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("MaxSize", QueueSizeValue (QueueSize (mode, qSize))),
                          true, "Verify that we can actually set the attribute MaxSize");
-  NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("A", DoubleValue (0.125)), true,
-                         "Verify that we can actually set the attribute A");
-  NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("B", DoubleValue (1.25)), true,
-                         "Verify that we can actually set the attribute B");
   NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("Tupdate", TimeValue (Seconds (0.03))), true,
                          "Verify that we can actually set the attribute Tupdate");
-  NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("Supdate", TimeValue (Seconds (0.0))), true,
-                         "Verify that we can actually set the attribute Supdate");
   NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("DequeueThreshold", UintegerValue (10000)), true,
                          "Verify that we can actually set the attribute DequeueThreshold");
   NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("QueueDelayReference", TimeValue (Seconds (0.08))), true,
@@ -264,7 +302,7 @@
   NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("MaxBurstAllowance", TimeValue (Seconds (0.1))), true,
                          "Verify that we can actually set the attribute MaxBurstAllowance");
   queue->Initialize ();
-  EnqueueWithDelay (queue, pktSize, 400);
+  EnqueueWithDelay (queue, pktSize, 400, testAttributes);
   DequeueWithDelay (queue, 0.012, 400);
   Simulator::Stop (Seconds (8.0));
   Simulator::Run ();
@@ -276,16 +314,12 @@
 
   // test 4: same as test 2, but with reduced dequeue rate
   queue = CreateObject<PieQueueDisc> ();
+  // PieQueueDiscItem pointer for attributes
+  testAttributes = Create<PieQueueDiscTestItem> (Create<Packet> (pktSize), dest, false);
   NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("MaxSize", QueueSizeValue (QueueSize (mode, qSize))),
                          true, "Verify that we can actually set the attribute MaxSize");
-  NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("A", DoubleValue (0.125)), true,
-                         "Verify that we can actually set the attribute A");
-  NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("B", DoubleValue (1.25)), true,
-                         "Verify that we can actually set the attribute B");
   NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("Tupdate", TimeValue (Seconds (0.03))), true,
                          "Verify that we can actually set the attribute Tupdate");
-  NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("Supdate", TimeValue (Seconds (0.0))), true,
-                         "Verify that we can actually set the attribute Supdate");
   NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("DequeueThreshold", UintegerValue (10000)), true,
                          "Verify that we can actually set the attribute DequeueThreshold");
   NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("QueueDelayReference", TimeValue (Seconds (0.02))), true,
@@ -293,7 +327,7 @@
   NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("MaxBurstAllowance", TimeValue (Seconds (0.1))), true,
                          "Verify that we can actually set the attribute MaxBurstAllowance");
   queue->Initialize ();
-  EnqueueWithDelay (queue, pktSize, 400);
+  EnqueueWithDelay (queue, pktSize, 400, testAttributes);
   DequeueWithDelay (queue, 0.015, 400); // delay between two successive dequeue events is increased
   Simulator::Stop (Seconds (8.0));
   Simulator::Run ();
@@ -305,16 +339,12 @@
 
   // test 5: same dequeue rate as test 4, but with higher Tupdate
   queue = CreateObject<PieQueueDisc> ();
+  // PieQueueDiscItem pointer for attributes
+  testAttributes = Create<PieQueueDiscTestItem> (Create<Packet> (pktSize), dest, false);
   NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("MaxSize", QueueSizeValue (QueueSize (mode, qSize))),
                          true, "Verify that we can actually set the attribute MaxSize");
-  NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("A", DoubleValue (0.125)), true,
-                         "Verify that we can actually set the attribute A");
-  NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("B", DoubleValue (1.25)), true,
-                         "Verify that we can actually set the attribute B");
   NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("Tupdate", TimeValue (Seconds (0.09))), true,
                          "Verify that we can actually set the attribute Tupdate");
-  NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("Supdate", TimeValue (Seconds (0.0))), true,
-                         "Verify that we can actually set the attribute Supdate");
   NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("DequeueThreshold", UintegerValue (10000)), true,
                          "Verify that we can actually set the attribute DequeueThreshold");
   NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("QueueDelayReference", TimeValue (Seconds (0.02))), true,
@@ -322,7 +352,7 @@
   NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("MaxBurstAllowance", TimeValue (Seconds (0.1))), true,
                          "Verify that we can actually set the attribute MaxBurstAllowance");
   queue->Initialize ();
-  EnqueueWithDelay (queue, pktSize, 400);
+  EnqueueWithDelay (queue, pktSize, 400, testAttributes);
   DequeueWithDelay (queue, 0.015, 400);
   Simulator::Stop (Seconds (8.0));
   Simulator::Run ();
